package com.ruoyi.info.service.service;

import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.info.service.domain.ServiceProduct;
import com.ruoyi.info.service.domain.bo.ServiceProductBo;
import com.ruoyi.info.service.domain.vo.ServiceCategorizeStatisticsVo;
import com.ruoyi.info.service.domain.vo.ServiceProductVo;

import java.util.Collection;
import java.util.List;

/**
 * 服务Service接口
 *
 * @author ruoyi
 * @date 2025-09-20
 */
public interface IServiceProductService {

    /**
     * 查询服务分页
     *
     * @param bo 服务
     * @return 服务集合
     */
    TableDataInfo<ServiceProductVo> queryPageList(ServiceProductBo bo, PageQuery pageQuery);

    /**
     * 查询服务列表
     *
     * @param bo 服务
     * @return 服务集合
     */
    List<ServiceProductVo> queryList(ServiceProductBo bo);

    /**
     * 查询服务
     *
     * @param id 服务主键
     * @return 服务
     */
    ServiceProductVo queryById(Long id);

    /**
     * 详情服务
     *
     * @param id 服务主键
     * @return 服务
     */
    ServiceProduct loadById(Long id, Boolean tw);

    /**
     * 新增服务
     *
     * @param bo 服务
     * @return 结果
     */
    Boolean insertByBo(ServiceProductBo bo);

    /**
     * 修改服务
     *
     * @param bo 服务
     * @return 结果
     */
    Boolean updateByBo(ServiceProductBo bo);

    /**
     * 校验并批量删除服务信息
     *
     * @param ids 需要删除的服务主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    boolean setStatus(Long id);

    ServiceProductVo queryDelById(Long id);

    List<ServiceCategorizeStatisticsVo> queryServiceCategorizeStatistics();

    Long countByCategorizeId(Collection<Long> ids);
}
